"use strict";
const inversify_1 = require("inversify");
const CommandModule_1 = require("./commands/configuration/CommandModule");
const CommandModule_2 = require("./commands/link/CommandModule");
const CommandModule_3 = require("./commands/unlink/CommandModule");
const CommandModule_4 = require("./commands/bump/CommandModule");
const CommandFactory_1 = require("./commands/CommandFactory");
class CLIModule extends inversify_1.ContainerModule {
    constructor() {
        super((bind) => {
            bind("CommandFactory").to(CommandFactory_1.CommandFactory);
            bind("configCommandModule").toDynamicValue((context) => {
                return new CommandModule_1.CommandModule();
            });
            bind("linkCommandModule").toDynamicValue((context) => {
                return new CommandModule_2.CommandModule();
            });
            bind("unlinkCommandModule").toDynamicValue((context) => {
                return new CommandModule_3.CommandModule();
            });
            bind("bumpCommandModule").toDynamicValue((context) => {
                return new CommandModule_4.CommandModule();
            });
        });
    }
}
exports.CLIModule = CLIModule;
//# sourceMappingURL=CLIModule.js.map