import {ContainerModule, interfaces} from "inversify";
import Bind = interfaces.Bind;
import {CommandModule as ConfigCommandModule} from "./commands/configuration/CommandModule";
import {CommandModule as LinkCommandModule} from "./commands/link/CommandModule";
import {CommandModule as UnlinkCommandModule} from "./commands/unlink/CommandModule";
import {CommandModule as BumpCommandModule} from "./commands/bump/CommandModule";
import {CommandFactory} from "./commands/CommandFactory";

export class CLIModule extends ContainerModule {

    constructor() {
        super((bind: Bind) => {
            bind<CommandFactory>("CommandFactory").to(CommandFactory);
            bind<ContainerModule>("configCommandModule").toDynamicValue((context: interfaces.Context) => {
                return new ConfigCommandModule();
            });
            bind<ContainerModule>("linkCommandModule").toDynamicValue((context: interfaces.Context) => {
                return new LinkCommandModule();
            });
            bind<ContainerModule>("unlinkCommandModule").toDynamicValue((context: interfaces.Context) => {
                return new UnlinkCommandModule();
            });
            bind<ContainerModule>("bumpCommandModule").toDynamicValue((context: interfaces.Context) => {
                return new BumpCommandModule();
            });
        });
    }

}