import {CommandBase} from "./core/CommandBase";
import {interfaces, Container, injectable} from "inversify";
import {ContainerLocator} from "./core/ContainerLocator";
import {FrameworkModule} from "nodevolution-framework";

@injectable()
export class CommandFactory {
    public create(cliContainer: interfaces.Container, commandName: string): CommandBase {
        let commandContainer = cliContainer.createChild();
        commandContainer.bind<ContainerLocator>("ContainerLocator").toConstantValue(new ContainerLocator(commandContainer));
        commandContainer.load(new FrameworkModule());
        let commandModule: interfaces.ContainerModule = cliContainer.get<interfaces.ContainerModule>(`${commandName}CommandModule`);
        commandContainer.load(commandModule);
        let command = commandContainer.get<CommandBase>("Command");
        return command;
    }
}