/// <reference types="inquirer" />
import * as inquirer from "inquirer";
import Answers = inquirer.Answers;
import { LoggingServiceFactory, ConfigurationService, VersionService, PackageService } from "nodevolution-framework";
import { ArgumentHandlerBase } from "../../core/ArgumentHandlerBase";
import { CommandArguments } from "../../core/CommandArguments";
export declare class BumpArgumentHandler extends ArgumentHandlerBase {
    private _configurationService;
    private _versionService;
    private _loggingService;
    private _packageService;
    private _configuration;
    private _packages;
    private _packageName;
    private _versionLevelChoice;
    constructor(loggingServiceFactory: LoggingServiceFactory, packageService: PackageService, configurationService: ConfigurationService, versionService: VersionService);
    initialize(): Promise<any>;
    prepare(args: CommandArguments): Promise<any>;
    handle(args: CommandArguments, answers: Answers): Promise<any>;
    private persistChanges(bumpInfos);
    private loadConfiguration(workingDirectory);
    private getVersionLevelChoices();
}
