import {injectable, inject} from "inversify";
import {ArgumentHandlerBase} from "../core/ArgumentHandlerBase";
import {ContainerLocator} from "../core/ContainerLocator";
import {InitArgumentHandler} from "./argumentHandlers/InitArgumentHandler";

@injectable()
export class ArgumentHandlerFactory {
    private _containerLocator: ContainerLocator;

    constructor(@inject("ContainerLocator") containerLocator: ContainerLocator) {
        this._containerLocator = containerLocator;
    }

    public create(argument: string): ArgumentHandlerBase {
        switch (argument) {
            case "init":
                return this._containerLocator.current.get<InitArgumentHandler>("InitArgumentHandler");
        }
    }

}