import {injectable} from "inversify";
import * as inquirer from "inquirer";
import Answers = inquirer.Answers;
import Question = inquirer.Question;
import {CommandArguments} from "./CommandArguments";

@injectable()
export abstract class ArgumentHandlerBase {

    public abstract initialize(): Promise<any>;
    public abstract prepare(args: CommandArguments): Promise<any>;
    public abstract handle(args: CommandArguments, answers: Answers): Promise<any>;

}