import {injectable, inject} from "inversify";
import {ArgumentHandlerBase} from "../core/ArgumentHandlerBase";
import {ContainerLocator} from "../core/ContainerLocator";
import {LinkArgumentHandler} from "./argumentHandlers/LinkArgumentHandler";

@injectable()
export class ArgumentHandlerFactory {
    private _containerLocator: ContainerLocator;

    constructor(@inject("ContainerLocator") containerLocator: ContainerLocator) {
        this._containerLocator = containerLocator;
    }

    public create(argument: string): ArgumentHandlerBase {
        switch (argument) {
            case "link":
                return this._containerLocator.current.get<LinkArgumentHandler>("LinkArgumentHandler");
        }
    }

}