"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
const CommandBase_1 = require("../core/CommandBase");
const inversify_1 = require("inversify");
const ArgumentHandlerFactory_1 = require("./ArgumentHandlerFactory");
let Command = class Command extends CommandBase_1.CommandBase {
    constructor(argumentHandlerFactory) {
        super();
        this._argumentHandlerFactory = argumentHandlerFactory;
    }
    execute(args) {
        let handler;
        handler = this._argumentHandlerFactory.create("link");
        return handler.initialize()
            .then(() => {
            return handler.prepare(args);
        }).then((answers) => {
            return handler.handle(args, answers);
        });
    }
};
Command = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.inject("ArgumentHandlerFactory")),
    __metadata("design:paramtypes", [ArgumentHandlerFactory_1.ArgumentHandlerFactory])
], Command);
exports.Command = Command;
//# sourceMappingURL=Command.js.map