import {ContainerModule, interfaces, injectable} from "inversify";
import Bind = interfaces.Bind;
import {Command} from "./Command";
import {CommandBase} from "../core/CommandBase";
import {ArgumentHandlerFactory} from "./ArgumentHandlerFactory";
import {ArgumentHandlerBase} from "../core/ArgumentHandlerBase";
import {LinkArgumentHandler} from "./argumentHandlers/LinkArgumentHandler";

@injectable()
export class CommandModule extends ContainerModule {

    constructor() {
        super((bind: Bind) => {
            bind<CommandBase>("Command").to(Command);
            bind<ArgumentHandlerFactory>("ArgumentHandlerFactory").to(ArgumentHandlerFactory);
            bind<ArgumentHandlerBase>("LinkArgumentHandler").to(LinkArgumentHandler);
        });
    }

}