import {injectable, inject} from "inversify";
import {ArgumentHandlerBase} from "../core/ArgumentHandlerBase";
import {ContainerLocator} from "../core/ContainerLocator";
import {UnlinkArgumentHandler} from "./argumentHandlers/UnlinkArgumentHandler";

@injectable()
export class ArgumentHandlerFactory {
    private _containerLocator: ContainerLocator;

    constructor(@inject("ContainerLocator") containerLocator: ContainerLocator) {
        this._containerLocator = containerLocator;
    }

    public create(argument: string): ArgumentHandlerBase {
        switch (argument) {
            case "unlink":
                return this._containerLocator.current.get<UnlinkArgumentHandler>("UnlinkArgumentHandler");
        }
    }

}