"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const Process = require("process");
const nodevolution_framework_1 = require("nodevolution-framework");
const nodevolution_framework_2 = require("nodevolution-framework");
const inversify_1 = require("inversify");
const ArgumentHandlerBase_1 = require("../../core/ArgumentHandlerBase");
let UnlinkArgumentHandler = class UnlinkArgumentHandler extends ArgumentHandlerBase_1.ArgumentHandlerBase {
    constructor(loggingServiceFactory, configurationService, linkService) {
        super();
        this._configurationService = configurationService;
        this._linkService = linkService;
        this._loggingService = loggingServiceFactory.create("UnlinkArgumentHandler");
    }
    initialize() {
        return new Promise((resolve) => {
            resolve();
        });
    }
    prepare(args) {
        return new Promise((resolve) => {
            resolve();
        });
    }
    handle(args, answers) {
        return __awaiter(this, void 0, void 0, function* () {
            this._loggingService.debug("start unlinking command");
            let workingDirectory = Process.cwd();
            this._loggingService.debug(`detected working directory ${workingDirectory}`);
            let configurationFilePath = this._configurationService.search(workingDirectory);
            if (configurationFilePath === undefined) {
                this._loggingService.warn(`no configuration file was detected. exiting`);
                return;
            }
            this._loggingService.debug(`loading configuration file from location ${configurationFilePath}`);
            let configuration = yield this._configurationService.load(configurationFilePath);
            this._loggingService.debug(`loaded configuration file`, configuration);
            this._loggingService.debug(`invoking unlinking service`, configuration.link);
            return this._linkService.unlink(configuration.link)
                .then(() => {
                this._loggingService.info(`unlinked projects successfully`);
            })
                .catch((error) => {
                this._loggingService.error("Error while unlinking projects", error);
                return;
            });
        });
    }
};
UnlinkArgumentHandler = __decorate([
    inversify_1.injectable(),
    __param(0, inversify_1.inject("LoggingServiceFactory")),
    __param(1, inversify_1.inject("ConfigurationService")),
    __param(2, inversify_1.inject("LinkService")),
    __metadata("design:paramtypes", [nodevolution_framework_2.LoggingServiceFactory,
        nodevolution_framework_1.ConfigurationService,
        nodevolution_framework_1.LinkService])
], UnlinkArgumentHandler);
exports.UnlinkArgumentHandler = UnlinkArgumentHandler;
//# sourceMappingURL=UnlinkArgumentHandler.js.map